
var myinterval;
var iMax = 11;
var jMax = 11;
var memory_array = new Array();

for (i=0;i<iMax;i++) {
 memory_array[i]=new Array();
 for (j=0;j<jMax;j++) {
  memory_array[i][j]=0;
 }
}

var hiscarray = memory_array.map(function(arr) {
    return arr.slice();
});


var score=0,maxscore=0;

var species = [0,1,2,3,4,5,6,7,
               8,8,9,9,10,10,11,11,12,12,13,13,14,14];

var specond = [
    []
    // species
    ,[1] 
    ,[1,1,1]
    
    ,[2,2,2]     
    ,[3,3]

    ,[3,4]
    ,[4,5]
    ,[4,5,6]
    // bugs
    ,[1,1,1,1]
    ,[8]            // 1
    ,[2,2,2,2]            // 1
    ,[9]            // 1
    ,[3,3,3]            // 1
    ,[10]            // 1
    ,[4,4,4]            // 1
    ,[11]            // 1
    ,[5,5]            // 1
    ,[12]            // 1
    ,[6,6]            // 1
    ,[13]            // 1
    ,[7,7]            // 1
    ,[14]            // 1
];

var specolor = ['','#0F0','#AF0','#CC0','#DB0','#0AA','#5BC','#9AF',
                '#FFF','#DDD','#BBB','#999','#777','#555','#333'];

function newBoard()
{
	var output = '';
	for(var i = 0; i < memory_array.length; i++)
    {
    	for(var j = 0; j < memory_array[i].length; j++)
        {
            output += 
                '<div id="tile_'+i+j+'" onclick="SetTile('+i+','+j+',0)"></div>';
        }
	}
	document.getElementById('memory_board').innerHTML = output;
}


function SetTile(i,j,k)
{
    memory_array[i][j]=k;

    tile=document.getElementById("tile_"+i+j);
    tile.style.background = specolor[k];
    tile.style.backgroundImage="url('bg"+memory_array[i][j]+".png')";
    //tile.innerHTML = memory_array[i][j]; 
}

function memoryFlipTile(i,j)
{
    var nb0 = neighbors(i,j);
    var k = 0;
    
    for(k = specond.length-1; k >= 0; k--)
    {
        var nb=nb0.slice();

        for(var l = 0; l < specond[k].length; l++)
        {
            m=nb.indexOf(specond[k][l]);

            if(m == -1) { break; }

            nb.splice(m,1);
        }

        if(l==specond[k].length) break;
    }

    k=species[k];

    if(k<=memory_array[i][j]) return -1;

    SetTile(i,j,k);

    return 0;
}

function neighbors(i,j)
{
    var nb=[];
    
    if(i>0) nb.push(memory_array[i-1][j]);
    if(i<iMax-1) nb.push(memory_array[i+1][j]);
    if(j>0) nb.push(memory_array[i][j-1]);
    if(j<jMax-1) nb.push(memory_array[i][j+1]);
    
    return(nb);
}

function mutation()
{
    var i=0;
    var s=-1;
    
    for(var t=0,s=-1;s<0&t<10;t++)
    {
        var i = Math.floor((Math.random() * iMax)); 
        var j = Math.floor((Math.random() * jMax)); 

        s=memoryFlipTile(i,j);
    }
    
    score=0;
    for(var i=0, n=memory_array.length; i < n; i++) 
    { 
       for(var j=0, n=memory_array[i].length; j < n; j++)
       {
           if(memory_array[i][j]<8) score += memory_array[i][j]*memory_array[i][j]; 
       }
    }
    
    if(score>maxscore)
    {
        maxscore=score;
        hiscarray = memory_array.map(function(arr) {
            return arr.slice();
        });
    }
    $('#score').html("Score: "+score+" / "+maxscore);
}

function hiscore()
{
	var output = '';
	for(var i = 0; i < hiscarray.length; i++)
    {
    	for(var j = 0; j < hiscarray[i].length; j++)
        {
                SetTile(i,j,hiscarray[i][j]);
        }
	}
    $('#highscore').css("visibility","hidden");
    $('#score').html("HiScore: "+maxscore);
    clearInterval(myinterval);
    $('#exit').css("width","100%");
}


$( document ).ready(function()
{
    newBoard();
    
    var i = Math.floor((Math.random() * iMax)); 
    var j = Math.floor((Math.random() * jMax)); 
    SetTile(i,j,1);
    
    myinterval=setInterval(mutation,400);
});


